diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/ipv4-address.h ns-3.47/src/network/utils/ipv4-address.h
--- ns-3.46/src/network/utils/ipv4-address.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/ipv4-address.h	2026-02-16 16:08:49.803230800 -0800
@@ -11,7 +11,9 @@
 
 #include "ns3/address.h"
 #include "ns3/attribute-helper.h"
+#include "ns3/deprecated.h"
 
+#include <compare>
 #include <ostream>
 #include <stdint.h>
 
@@ -30,7 +32,7 @@
 class Ipv4Address
 {
   public:
-    Ipv4Address();
+    Ipv4Address() = default;
     /**
      * input address is in host order.
      * @param address The host order 32-bit address
@@ -43,9 +45,28 @@
      * \c hhh.xxx.xxx.lll
      * where \c h is the high byte and \c l the
      * low byte
+     *
      * @param address C-string containing the address as described above
      */
     Ipv4Address(const char* address);
+
+    /**
+     * @brief Checks if the string contains an Ipv4Address
+     *
+     * Input address is in format:
+     * \c hhh.xxx.xxx.lll
+     * where \c h is the high byte and \c l the
+     * low byte
+     *
+     * Note: the function uses ``inet_pton`` internally.
+     *
+     * @see Address::CheckCompatible hich has a similar name but which
+     * instead checks the underlying type and length embedded in the Address.
+     *
+     * @param addressStr string containing the address as described above
+     * @return true if the string can be parsed as an IPv4 address
+     */
+    static bool CheckCompatible(const std::string& addressStr);
     /**
      * Get the host-order 32-bit IP address
      * @return the host-order 32-bit IP address
@@ -91,6 +112,7 @@
     /**
      * @return true if address is initialized (i.e., set to something), false otherwise
      */
+    NS_DEPRECATED_3_47("Use IsAny or std::optional")
     bool IsInitialized() const;
     /**
      * @return true if address is 0.0.0.0; false otherwise
@@ -190,6 +212,7 @@
     static Ipv4Address GetZero();
     /**
      * @return the 0.0.0.0 address
+     * @hidecaller
      */
     static Ipv4Address GetAny();
     /**
@@ -201,42 +224,22 @@
      */
     static Ipv4Address GetLoopback();
 
-  private:
-    /**
-     * @brief Get the underlying address type (automatically assigned).
-     *
-     * @returns the address type
-     */
-    static uint8_t GetType();
-    uint32_t m_address; //!< IPv4 address
-    bool m_initialized; //!< IPv4 address has been explicitly initialized to a valid value.
-
-    /**
-     * @brief Equal to operator.
-     *
-     * @param a the first operand.
-     * @param b the first operand.
-     * @returns true if the operands are equal.
-     */
-    friend bool operator==(const Ipv4Address& a, const Ipv4Address& b);
-
     /**
-     * @brief Not equal to operator.
+     * @brief Three-way comparison operator.
      *
-     * @param a the first operand.
-     * @param b the first operand.
-     * @returns true if the operands are not equal.
+     * @param other the other address to compare with
+     * @returns comparison result
      */
-    friend bool operator!=(const Ipv4Address& a, const Ipv4Address& b);
+    constexpr std::strong_ordering operator<=>(const Ipv4Address& other) const = default;
 
+  private:
     /**
-     * @brief Less than to operator.
+     * @brief Get the underlying address type (automatically assigned).
      *
-     * @param a the first operand.
-     * @param b the first operand.
-     * @returns true if the first operand is less than the second.
+     * @returns the address type
      */
-    friend bool operator<(const Ipv4Address& a, const Ipv4Address& b);
+    static uint8_t GetType();
+    uint32_t m_address{0}; //!< IPv4 address
 };
 
 /**
@@ -254,9 +257,9 @@
 {
   public:
     /**
-     * Will initialize to a garbage value (0x66666666)
+     * Will initialize to a zero-length mask, which will match any address.
      */
-    Ipv4Mask();
+    Ipv4Mask() = default;
     /**
      * @param mask bitwise integer representation of the mask
      *
@@ -314,25 +317,15 @@
     static Ipv4Mask GetOnes();
 
     /**
-     * @brief Equal to operator.
-     *
-     * @param a the first operand.
-     * @param b the first operand.
-     * @returns true if the operands are equal.
-     */
-    friend bool operator==(const Ipv4Mask& a, const Ipv4Mask& b);
-
-    /**
-     * @brief Not equal to operator.
+     * @brief Three-way comparison operator.
      *
-     * @param a the first operand.
-     * @param b the first operand.
-     * @returns true if the operands are not equal.
+     * @param a the other mask to compare with
+     * @returns comparison result
      */
-    friend bool operator!=(const Ipv4Mask& a, const Ipv4Mask& b);
+    constexpr std::strong_ordering operator<=>(const Ipv4Mask& a) const = default;
 
   private:
-    uint32_t m_mask; //!< IP mask
+    uint32_t m_mask{0}; //!< IP mask
 };
 
 ATTRIBUTE_HELPER_HEADER(Ipv4Address);
@@ -371,30 +364,12 @@
  */
 std::istream& operator>>(std::istream& is, Ipv4Mask& mask);
 
-inline bool
-operator==(const Ipv4Address& a, const Ipv4Address& b)
-{
-    return a.m_address == b.m_address;
-}
-
-inline bool
-operator!=(const Ipv4Address& a, const Ipv4Address& b)
-{
-    return a.m_address != b.m_address;
-}
-
-inline bool
-operator<(const Ipv4Address& a, const Ipv4Address& b)
-{
-    return a.m_address < b.m_address;
-}
-
 /**
  * @ingroup address
  *
  * @brief Class providing an hash for IPv4 addresses
  */
-class Ipv4AddressHash
+class NS_DEPRECATED_3_47("Unnecessary thanks to std::hash specialization, remove") Ipv4AddressHash
 {
   public:
     /**
@@ -408,18 +383,27 @@
     size_t operator()(const Ipv4Address& x) const;
 };
 
-inline bool
-operator==(const Ipv4Mask& a, const Ipv4Mask& b)
-{
-    return a.m_mask == b.m_mask;
-}
+} // namespace ns3
 
-inline bool
-operator!=(const Ipv4Mask& a, const Ipv4Mask& b)
+namespace std
 {
-    return a.m_mask != b.m_mask;
-}
 
-} // namespace ns3
+/**
+ * @brief Hash function class for IPv4 addresses.
+ */
+template <>
+struct hash<ns3::Ipv4Address>
+{
+    /**
+     * @brief Returns the hash of an IPv4 address.
+     * @param addr IPv4 address to hash
+     * @returns the hash of the address
+     */
+    size_t operator()(const ns3::Ipv4Address& addr) const
+    {
+        return std::hash<uint32_t>()(addr.Get());
+    }
+};
+} // namespace std
 
 #endif /* IPV4_ADDRESS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/ipv6-address.cc ns-3.47/src/network/utils/ipv6-address.cc
--- ns-3.46/src/network/utils/ipv6-address.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/ipv6-address.cc	2026-02-16 16:08:49.804230700 -0800
@@ -15,6 +15,7 @@
 #include "ns3/assert.h"
 #include "ns3/log.h"
 
+#include <algorithm>
 #include <iomanip>
 #include <memory>
 
@@ -30,197 +31,67 @@
 
 NS_LOG_COMPONENT_DEFINE("Ipv6Address");
 
-#ifdef __cplusplus
-extern "C"
-{ /* } */
-#endif
-    /**
-     * @brief Mix hash keys in-place for lookuphash
-     *
-     * @param a first word of the hash key
-     * @param b second word of the hash key
-     * @param c third word of the hash key
-     */
-    void mixHashKey(uint32_t& a, uint32_t& b, uint32_t& c)
-    {
-        (a) -= (b);
-        (a) -= (c);
-        (a) ^= ((c) >> 13);
-        (b) -= (c);
-        (b) -= (a);
-        (b) ^= ((a) << 8);
-        (c) -= (a);
-        (c) -= (b);
-        (c) ^= ((b) >> 13);
-        (a) -= (b);
-        (a) -= (c);
-        (a) ^= ((c) >> 12);
-        (b) -= (c);
-        (b) -= (a);
-        (b) ^= ((a) << 16);
-        (c) -= (a);
-        (c) -= (b);
-        (c) ^= ((b) >> 5);
-        (a) -= (b);
-        (a) -= (c);
-        (a) ^= ((c) >> 3);
-        (b) -= (c);
-        (b) -= (a);
-        (b) ^= ((a) << 10);
-        (c) -= (a);
-        (c) -= (b);
-        (c) ^= ((b) >> 15);
-    }
-
-    /**
-     * @brief Get a hash key.
-     * @param k the key
-     * @param length the length of the key
-     * @param level the previous hash, or an arbitrary value
-     * @return hash
-     * @note Adapted from Jens Jakobsen implementation (chillispot).
-     */
-    static uint32_t lookuphash(unsigned char* k, uint32_t length, uint32_t level)
-    {
-        NS_LOG_FUNCTION(k << length << level);
-
-        typedef uint32_t ub4; /* unsigned 4-byte quantities */
-        uint32_t a = 0;
-        uint32_t b = 0;
-        uint32_t c = 0;
-        uint32_t len = 0;
-
-        /* Set up the internal state */
-        len = length;
-        a = b = 0x9e3779b9; /* the golden ratio; an arbitrary value */
-        c = level;          /* the previous hash value */
-
-        /* handle most of the key */
-        while (len >= 12)
-        {
-            a += (k[0] + ((ub4)k[1] << 8) + ((ub4)k[2] << 16) + ((ub4)k[3] << 24));
-            b += (k[4] + ((ub4)k[5] << 8) + ((ub4)k[6] << 16) + ((ub4)k[7] << 24));
-            c += (k[8] + ((ub4)k[9] << 8) + ((ub4)k[10] << 16) + ((ub4)k[11] << 24));
-            mixHashKey(a, b, c);
-            k += 12;
-            len -= 12;
-        }
-
-        /* handle the last 11 bytes */
-        c += length;
-        switch (len) /* all the case statements fall through */
-        {
-        case 11:
-            c += ((ub4)k[10] << 24);
-        case 10:
-            c += ((ub4)k[9] << 16);
-        case 9:
-            c += ((ub4)k[8] << 8); /* the first byte of c is reserved for the length */
-        case 8:
-            b += ((ub4)k[7] << 24);
-        case 7:
-            b += ((ub4)k[6] << 16);
-        case 6:
-            b += ((ub4)k[5] << 8);
-        case 5:
-            b += k[4];
-        case 4:
-            a += ((ub4)k[3] << 24);
-        case 3:
-            a += ((ub4)k[2] << 16);
-        case 2:
-            a += ((ub4)k[1] << 8);
-        case 1:
-            a += k[0];
-            /* case 0: nothing left to add */
-        }
-        mixHashKey(a, b, c);
-
-        /* report the result */
-        return c;
-    }
-
-#ifdef __cplusplus
-}
-#endif
-
-Ipv6Address::Ipv6Address()
+Ipv6Address::Ipv6Address(const char* address)
 {
-    NS_LOG_FUNCTION(this);
-    memset(m_address, 0x00, 16);
-    m_initialized = false;
-}
+    NS_LOG_FUNCTION(this << address);
 
-Ipv6Address::Ipv6Address(const Ipv6Address& addr)
-{
-    // Do not add function logging here, to avoid stack overflow
-    memcpy(m_address, addr.m_address, 16);
-    m_initialized = true;
+    if (inet_pton(AF_INET6, address, m_address.data()) <= 0)
+    {
+        m_address.fill(0x00);
+        NS_ABORT_MSG("Error, can not build an IPv6 address from an invalid string: " << address);
+        return;
+    }
+    m_hash.reset();
 }
 
-Ipv6Address::Ipv6Address(const Ipv6Address* addr)
+bool
+Ipv6Address::CheckCompatible(const std::string& addressStr)
 {
-    // Do not add function logging here, to avoid stack overflow
-    memcpy(m_address, addr->m_address, 16);
-    m_initialized = true;
-}
+    NS_LOG_FUNCTION(addressStr);
 
-Ipv6Address::Ipv6Address(const char* address)
-{
-    NS_LOG_FUNCTION(this << address);
+    uint8_t buffer[16];
 
-    if (inet_pton(AF_INET6, address, m_address) <= 0)
+    if (inet_pton(AF_INET6, addressStr.c_str(), &buffer) <= 0)
     {
-        memset(m_address, 0x00, 16);
-        NS_LOG_LOGIC("Error, can not build an IPv6 address from an invalid string: " << address);
-        m_initialized = false;
-        return;
+        NS_LOG_WARN("Error, can not build an IPv6 address from an invalid string: " << addressStr);
+        return false;
     }
-    m_initialized = true;
+    return true;
 }
 
 Ipv6Address::Ipv6Address(uint8_t address[16])
 {
     NS_LOG_FUNCTION(this << &address);
-    /* 128 bit => 16 bytes */
-    memcpy(m_address, address, 16);
-    m_initialized = true;
-}
-
-Ipv6Address::~Ipv6Address()
-{
-    /* do nothing */
-    NS_LOG_FUNCTION(this);
+    std::copy(address, address + 16, m_address.begin());
+    m_hash.reset();
 }
 
 void
 Ipv6Address::Set(const char* address)
 {
     NS_LOG_FUNCTION(this << address);
-    if (inet_pton(AF_INET6, address, m_address) <= 0)
+    if (inet_pton(AF_INET6, address, m_address.data()) <= 0)
     {
-        memset(m_address, 0x00, 16);
-        NS_LOG_LOGIC("Error, can not build an IPv6 address from an invalid string: " << address);
-        m_initialized = false;
+        m_address.fill(0x00);
+        NS_ABORT_MSG("Error, can not set an IPv6 address from an invalid string: " << address);
         return;
     }
-    m_initialized = true;
+    m_hash.reset();
 }
 
 void
 Ipv6Address::Set(uint8_t address[16])
 {
-    /* 128 bit => 16 bytes */
     NS_LOG_FUNCTION(this << &address);
-    memcpy(m_address, address, 16);
-    m_initialized = true;
+    std::copy(address, address + 16, m_address.begin());
+    m_hash.reset();
 }
 
 void
 Ipv6Address::Serialize(uint8_t buf[16]) const
 {
     NS_LOG_FUNCTION(this << &buf);
-    memcpy(buf, m_address, 16);
+    std::copy(m_address.begin(), m_address.end(), buf);
 }
 
 Ipv6Address
@@ -228,7 +99,6 @@
 {
     NS_LOG_FUNCTION(&buf);
     Ipv6Address ipv6((uint8_t*)buf);
-    ipv6.m_initialized = true;
     return ipv6;
 }
 
@@ -236,24 +106,11 @@
 Ipv6Address::MakeIpv4MappedAddress(Ipv4Address addr)
 {
     NS_LOG_FUNCTION(addr);
-    uint8_t buf[16] = {
-        0x00,
-        0x00,
-        0x00,
-        0x00,
-        0x00,
-        0x00,
-        0x00,
-        0x00,
-        0x00,
-        0x00,
-        0xff,
-        0xff,
-        0x00,
-        0x00,
-        0x00,
-        0x00,
-    };
+    uint8_t buf[16] = {0};
+
+    buf[10] = 0xff;
+    buf[11] = 0xff;
+
     addr.Serialize(&buf[12]);
     return Ipv6Address(buf);
 }
@@ -529,7 +386,7 @@
 
     char str[INET6_ADDRSTRLEN];
 
-    if (inet_ntop(AF_INET6, m_address, str, INET6_ADDRSTRLEN))
+    if (inet_ntop(AF_INET6, m_address.data(), str, INET6_ADDRSTRLEN))
     {
         os << str;
     }
@@ -561,9 +418,9 @@
 Ipv6Address::IsIpv4MappedAddress() const
 {
     NS_LOG_FUNCTION(this);
-    static uint8_t v4MappedPrefix[12] =
+    static std::array<uint8_t, 12> v4MappedPrefix =
         {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff};
-    return memcmp(m_address, v4MappedPrefix, sizeof(v4MappedPrefix)) == 0;
+    return std::equal(v4MappedPrefix.begin(), v4MappedPrefix.end(), m_address.begin());
 }
 
 Ipv6Address
@@ -575,10 +432,9 @@
     uint8_t pref[16];
     unsigned int i = 0;
 
-    memcpy(addr, m_address, 16);
+    std::copy(m_address.begin(), m_address.end(), addr);
     ((Ipv6Prefix)prefix).GetBytes(pref);
 
-    /* a little bit ugly... */
     for (i = 0; i < 16; i++)
     {
         addr[i] = addr[i] & pref[i];
@@ -681,7 +537,7 @@
 Ipv6Address::GetType()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static uint8_t type = Address::Register();
+    static uint8_t type = Address::Register("IpAddress", 16);
     return type;
 }
 
@@ -745,7 +601,7 @@
 Ipv6Address::GetBytes(uint8_t buf[16]) const
 {
     NS_LOG_FUNCTION(this << &buf);
-    memcpy(buf, m_address, 16);
+    std::copy(m_address.begin(), m_address.end(), buf);
 }
 
 bool
@@ -760,7 +616,68 @@
 Ipv6Address::IsInitialized() const
 {
     NS_LOG_FUNCTION(this);
-    return m_initialized;
+    return true;
+}
+
+void
+Ipv6Address::MixHashKey(uint32_t& a, uint32_t& b, uint32_t& c)
+{
+    auto mix = [](uint32_t x, uint32_t y, uint32_t z, int shift) -> uint32_t {
+        x -= y + z;
+        x ^= (shift > 0) ? (z << shift) : (z >> (-shift));
+        return x;
+    };
+
+    a = mix(a, b, c, -13);
+    b = mix(b, c, a, 8);
+    c = mix(c, a, b, -13);
+    a = mix(a, b, c, -12);
+    b = mix(b, c, a, 16);
+    c = mix(c, a, b, -5);
+    a = mix(a, b, c, -3);
+    b = mix(b, c, a, 10);
+    c = mix(c, a, b, -15);
+}
+
+uint32_t
+Ipv6Address::GenerateHash() const
+{
+    NS_LOG_FUNCTION(this);
+
+    uint32_t a = 0x9e3779b9; /* the golden ratio; an arbitrary value */
+    uint32_t b = 0x9e3779b9; /* the golden ratio; an arbitrary value */
+    uint32_t c = 0;
+
+    auto fold = [](const uint8_t* a) -> uint32_t {
+        auto f = static_cast<uint32_t>(a[0]);
+        f += static_cast<uint32_t>(a[1]) << 8;
+        f += static_cast<uint32_t>(a[2]) << 16;
+        f += static_cast<uint32_t>(a[3]) << 24;
+        return f;
+    };
+
+    a += fold(&m_address[0]);
+    b += fold(&m_address[4]);
+    c += fold(&m_address[8]);
+    MixHashKey(a, b, c);
+
+    c += 16;
+    a += fold(&m_address[12]);
+    MixHashKey(a, b, c);
+
+    /* set the hash and report the result */
+    m_hash = c;
+    return c;
+}
+
+uint32_t
+Ipv6Address::GetHash() const
+{
+    if (m_hash)
+    {
+        return m_hash.value();
+    }
+    return GenerateHash();
 }
 
 std::ostream&
@@ -779,17 +696,10 @@
     return is;
 }
 
-Ipv6Prefix::Ipv6Prefix()
-{
-    NS_LOG_FUNCTION(this);
-    memset(m_prefix, 0x00, 16);
-    m_prefixLength = 64;
-}
-
 Ipv6Prefix::Ipv6Prefix(const char* prefix)
 {
     NS_LOG_FUNCTION(this << prefix);
-    if (inet_pton(AF_INET6, prefix, m_prefix) <= 0)
+    if (inet_pton(AF_INET6, prefix, m_prefix.data()) <= 0)
     {
         NS_ABORT_MSG("Error, can not build an IPv6 prefix from an invalid string: " << prefix);
     }
@@ -799,14 +709,14 @@
 Ipv6Prefix::Ipv6Prefix(uint8_t prefix[16])
 {
     NS_LOG_FUNCTION(this << &prefix);
-    memcpy(m_prefix, prefix, 16);
+    std::copy(prefix, prefix + 16, m_prefix.begin());
     m_prefixLength = GetMinimumPrefixLength();
 }
 
 Ipv6Prefix::Ipv6Prefix(const char* prefix, uint8_t prefixLength)
 {
     NS_LOG_FUNCTION(this << prefix);
-    if (inet_pton(AF_INET6, prefix, m_prefix) <= 0)
+    if (inet_pton(AF_INET6, prefix, m_prefix.data()) <= 0)
     {
         NS_ABORT_MSG("Error, can not build an IPv6 prefix from an invalid string: " << prefix);
     }
@@ -821,7 +731,7 @@
 Ipv6Prefix::Ipv6Prefix(uint8_t prefix[16], uint8_t prefixLength)
 {
     NS_LOG_FUNCTION(this << &prefix);
-    memcpy(m_prefix, prefix, 16);
+    std::copy(prefix, prefix + 16, m_prefix.begin());
 
     uint8_t autoLength = GetMinimumPrefixLength();
     NS_ASSERT_MSG(autoLength <= prefixLength,
@@ -838,7 +748,7 @@
     unsigned int mod = 0;
     unsigned int i = 0;
 
-    memset(m_prefix, 0x00, 16);
+    m_prefix.fill(0x00);
     m_prefixLength = prefix;
 
     NS_ASSERT(prefix <= 128);
@@ -850,7 +760,7 @@
     // __warn_memset_zero_len compiler errors in some gcc>4.5.x
     if (nb > 0)
     {
-        memset(m_prefix, 0xff, nb);
+        memset(m_prefix.data(), 0xff, nb);
     }
     if (mod)
     {
@@ -867,24 +777,6 @@
     }
 }
 
-Ipv6Prefix::Ipv6Prefix(const Ipv6Prefix& prefix)
-{
-    memcpy(m_prefix, prefix.m_prefix, 16);
-    m_prefixLength = prefix.m_prefixLength;
-}
-
-Ipv6Prefix::Ipv6Prefix(const Ipv6Prefix* prefix)
-{
-    memcpy(m_prefix, prefix->m_prefix, 16);
-    m_prefixLength = prefix->m_prefixLength;
-}
-
-Ipv6Prefix::~Ipv6Prefix()
-{
-    /* do nothing */
-    NS_LOG_FUNCTION(this);
-}
-
 bool
 Ipv6Prefix::IsMatch(Ipv6Address a, Ipv6Address b) const
 {
@@ -943,16 +835,16 @@
 Ipv6Prefix::GetBytes(uint8_t buf[16]) const
 {
     NS_LOG_FUNCTION(this << &buf);
-    memcpy(buf, m_prefix, 16);
+    memcpy(buf, m_prefix.data(), 16);
 }
 
 Ipv6Address
 Ipv6Prefix::ConvertToIpv6Address() const
 {
     uint8_t prefixBytes[16];
-    memcpy(prefixBytes, m_prefix, 16);
+    memcpy(prefixBytes, m_prefix.data(), 16);
 
-    Ipv6Address convertedPrefix = Ipv6Address(prefixBytes);
+    auto convertedPrefix = Ipv6Address(prefixBytes);
     return convertedPrefix;
 }
 
@@ -1018,11 +910,7 @@
 size_t
 Ipv6AddressHash::operator()(const Ipv6Address& x) const
 {
-    uint8_t buf[16];
-
-    x.GetBytes(buf);
-
-    return lookuphash(buf, sizeof(buf), 0);
+    return x.GetHash();
 }
 
 ATTRIBUTE_HELPER_CPP(Ipv6Address);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/ipv6-address.h ns-3.47/src/network/utils/ipv6-address.h
--- ns-3.46/src/network/utils/ipv6-address.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/ipv6-address.h	2026-02-16 16:08:49.804230700 -0800
@@ -14,8 +14,12 @@
 
 #include "ns3/address.h"
 #include "ns3/attribute-helper.h"
+#include "ns3/deprecated.h"
 
+#include <array>
+#include <compare>
 #include <cstring>
+#include <optional>
 #include <ostream>
 #include <stdint.h>
 
@@ -40,15 +44,31 @@
     /**
      * @brief Default constructor.
      */
-    Ipv6Address();
+    Ipv6Address() = default;
 
     /**
      * @brief Constructs an Ipv6Address by parsing the input C-string.
-     * @param address the C-string containing the IPv6 address (e.g. 2001:660:4701::1).
+     * @param address the C-string containing the IPv6 address (e.g. 2001:db8:f00d:cafe::1).
      */
     Ipv6Address(const char* address);
 
     /**
+     * @brief Checks if the string contains an Ipv6Address
+     *
+     * Input address is in format:
+     * \c 2001:db8:f00d:cafe::1
+     *
+     * Note: the function uses ``inet_pton`` internally.
+     *
+     * @see Address::CheckCompatible hich has a similar name but which
+     * instead checks the underlying type and length embedded in the Address.
+     *
+     * @param addressStr string containing the address as described above
+     * @return true if the string can be parsed as an IPv6 address
+     */
+    static bool CheckCompatible(const std::string& addressStr);
+
+    /**
      * @brief Constructs an Ipv6Address by using the input 16 bytes.
      * @param address the 128-bit address
      * @warning the parameter must point on a 16 bytes integer array!
@@ -56,25 +76,8 @@
     Ipv6Address(uint8_t address[16]);
 
     /**
-     * @brief Copy constructor.
-     * @param addr Ipv6Address object
-     */
-    Ipv6Address(const Ipv6Address& addr);
-
-    /**
-     * @brief Copy constructor.
-     * @param addr Ipv6Address pointer
-     */
-    Ipv6Address(const Ipv6Address* addr);
-
-    /**
-     * @brief Destructor.
-     */
-    ~Ipv6Address();
-
-    /**
      * @brief Sets an Ipv6Address by parsing the input C-string.
-     * @param address the C-string containing the IPv6 address (e.g. 2001:660:4701::1).
+     * @param address the C-string containing the IPv6 address (e.g. 2001:db8:f00d:cafe::1).
      */
     void Set(const char* address);
 
@@ -342,6 +345,7 @@
     /**
      * @return true if address is initialized (i.e., set to something), false otherwise
      */
+    NS_DEPRECATED_3_47("Use IsAny or std::optional")
     bool IsInitialized() const;
 
     /**
@@ -392,45 +396,66 @@
      */
     void GetBytes(uint8_t buf[16]) const;
 
-  private:
     /**
-     * @brief Return the Type of address.
-     * @return type of address
+     * @brief Get the address hash.
+     * @return the address hash
      */
-    static uint8_t GetType();
+    uint32_t GetHash() const;
 
     /**
-     * @brief The address representation on 128 bits (16 bytes).
+     * @brief Three-way comparison operator.
+     *
+     * @param other the other address to compare with
+     * @returns comparison result
      */
-    uint8_t m_address[16];
-    bool m_initialized; //!< IPv6 address has been explicitly initialized to a valid value.
+    inline constexpr std::strong_ordering operator<=>(const Ipv6Address& other) const
+    {
+        return m_address <=> other.m_address;
+    }
 
     /**
      * @brief Equal to operator.
      *
-     * @param a the first operand.
-     * @param b the first operand.
+     * @param other the other address to compare with
      * @returns true if the operands are equal.
      */
-    friend bool operator==(const Ipv6Address& a, const Ipv6Address& b);
+    inline constexpr bool operator==(const Ipv6Address& other) const
+    {
+        return m_address == other.m_address;
+    }
 
+  private:
     /**
-     * @brief Not equal to operator.
+     * @brief Mix hash keys in-place for lookuphash
      *
-     * @param a the first operand.
-     * @param b the first operand.
-     * @returns true if the operands are not equal.
+     * @param a first word of the hash key
+     * @param b second word of the hash key
+     * @param c third word of the hash key
      */
-    friend bool operator!=(const Ipv6Address& a, const Ipv6Address& b);
+    static void MixHashKey(uint32_t& a, uint32_t& b, uint32_t& c);
 
     /**
-     * @brief Less than to operator.
-     *
-     * @param a the first operand.
-     * @param b the first operand.
-     * @returns true if the first operand is less than the second.
+     * @brief Generate and return a hash key.
+     * @return hash
+     * @note Adapted from Jens Jakobsen implementation (chillispot).
      */
-    friend bool operator<(const Ipv6Address& a, const Ipv6Address& b);
+    uint32_t GenerateHash() const;
+
+    /**
+     * @brief Return the Type of address.
+     * @return type of address
+     */
+    static uint8_t GetType();
+
+    /**
+     * @brief The address representation on 128 bits (16 bytes).
+     */
+    std::array<uint8_t, 16> m_address{};
+
+    /**
+     * @brief address hash.
+     */
+    mutable std::optional<uint32_t> m_hash;
 };
 
 /**
@@ -445,14 +470,16 @@
   public:
     /**
      * @brief Default constructor.
+     *
+     * The default prefix is empty, corresponding to /0
      */
-    Ipv6Prefix();
+    Ipv6Prefix() = default;
 
     /**
      * @brief Constructs an Ipv6Prefix by using the input 16 bytes.
      *
      * The prefix length is calculated as the minimum prefix length, i.e.,
-     * 2001:db8:cafe:: will have a 47 bit prefix length.
+     * 2001:db8:cafe:: will have a 47 bit prefix length (0xE is 0b1110).
      *
      * @param prefix the 128-bit prefix
      */
@@ -490,27 +517,17 @@
     Ipv6Prefix(uint8_t prefix);
 
     /**
-     * @brief Copy constructor.
-     * @param prefix Ipv6Prefix object
-     */
-    Ipv6Prefix(const Ipv6Prefix& prefix);
-
-    /**
-     * @brief Copy constructor.
-     * @param prefix Ipv6Prefix pointer
-     */
-    Ipv6Prefix(const Ipv6Prefix* prefix);
-
-    /**
-     * @brief Destructor.
-     */
-    ~Ipv6Prefix();
-
-    /**
-     * @brief If the Address match the type.
-     * @param a a first address
-     * @param b a second address
-     * @return true if the type match, false otherwise
+     * @brief Check whether two addresses have the same bits in the prefix
+     * portion of their addresses.
+     *
+     * If the prefix length is 0, this method will return true regardless
+     * of the two address argument values.  If the prefix length is 128,
+     * this method will require that the two address arguments are the same.
+     *
+     * @param a first address to compare
+     * @param b second address to compare
+     * @return true if both addresses are equal in their masked bits,
+     * corresponding to the prefix length.
      */
     bool IsMatch(Ipv6Address a, Ipv6Address b) const;
 
@@ -571,34 +588,24 @@
      */
     static Ipv6Prefix GetZero();
 
-  private:
     /**
-     * @brief The prefix representation.
-     */
-    uint8_t m_prefix[16];
-
-    /**
-     * @brief The prefix length.
+     * @brief Three-way comparison operator.
+     *
+     * @param other the other prefix to compare with
+     * @returns comparison result
      */
-    uint8_t m_prefixLength;
+    constexpr std::strong_ordering operator<=>(const Ipv6Prefix& other) const = default;
 
+  private:
     /**
-     * @brief Equal to operator.
-     *
-     * @param a the first operand
-     * @param b the first operand
-     * @returns true if the operands are equal
+     * @brief The prefix representation.
      */
-    friend bool operator==(const Ipv6Prefix& a, const Ipv6Prefix& b);
+    std::array<uint8_t, 16> m_prefix{};
 
     /**
-     * @brief Not equal to operator.
-     *
-     * @param a the first operand
-     * @param b the first operand
-     * @returns true if the operands are not equal
+     * @brief The prefix length.
      */
-    friend bool operator!=(const Ipv6Prefix& a, const Ipv6Prefix& b);
+    uint8_t m_prefixLength{0};
 };
 
 ATTRIBUTE_HELPER_HEADER(Ipv6Address);
@@ -640,41 +647,11 @@
  */
 std::istream& operator>>(std::istream& is, Ipv6Prefix& prefix);
 
-inline bool
-operator==(const Ipv6Address& a, const Ipv6Address& b)
-{
-    return !std::memcmp(a.m_address, b.m_address, 16);
-}
-
-inline bool
-operator!=(const Ipv6Address& a, const Ipv6Address& b)
-{
-    return std::memcmp(a.m_address, b.m_address, 16);
-}
-
-inline bool
-operator<(const Ipv6Address& a, const Ipv6Address& b)
-{
-    return std::memcmp(a.m_address, b.m_address, 16) < 0;
-}
-
-inline bool
-operator==(const Ipv6Prefix& a, const Ipv6Prefix& b)
-{
-    return !std::memcmp(a.m_prefix, b.m_prefix, 16);
-}
-
-inline bool
-operator!=(const Ipv6Prefix& a, const Ipv6Prefix& b)
-{
-    return std::memcmp(a.m_prefix, b.m_prefix, 16);
-}
-
 /**
  * @class Ipv6AddressHash
  * @brief Hash function class for IPv6 addresses.
  */
-class Ipv6AddressHash
+class NS_DEPRECATED_3_47("Unnecessary thanks to std::hash specialization, remove") Ipv6AddressHash
 {
   public:
     /**
@@ -687,4 +664,25 @@
 
 } /* namespace ns3 */
 
+namespace std
+{
+
+/**
+ * @brief Hash function class for IPv6 addresses.
+ */
+template <>
+struct hash<ns3::Ipv6Address>
+{
+    /**
+     * @brief Returns the hash of an IPv6 address.
+     * @param addr IPv6 address to hash
+     * @returns the hash of the address
+     */
+    size_t operator()(const ns3::Ipv6Address& addr) const
+    {
+        return addr.GetHash();
+    }
+};
+} // namespace std
+
 #endif /* IPV6_ADDRESS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/mac16-address.cc ns-3.47/src/network/utils/mac16-address.cc
--- ns-3.46/src/network/utils/mac16-address.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/mac16-address.cc	2026-02-16 16:08:49.804230700 -0800
@@ -51,14 +51,14 @@
 Mac16Address::CopyFrom(const uint8_t buffer[2])
 {
     NS_LOG_FUNCTION(this << &buffer);
-    memcpy(m_address, buffer, 2);
+    std::copy(buffer, buffer + 2, m_address.begin());
 }
 
 void
 Mac16Address::CopyTo(uint8_t buffer[2]) const
 {
     NS_LOG_FUNCTION(this << &buffer);
-    memcpy(buffer, m_address, 2);
+    std::copy(m_address.begin(), m_address.end(), buffer);
 }
 
 bool
@@ -80,7 +80,7 @@
     NS_LOG_FUNCTION(address);
     NS_ASSERT(address.CheckCompatible(GetType(), 2));
     Mac16Address retval;
-    address.CopyTo(retval.m_address);
+    address.CopyTo(retval.m_address.data());
     return retval;
 }
 
@@ -88,7 +88,7 @@
 Mac16Address::ConvertTo() const
 {
     NS_LOG_FUNCTION(this);
-    return Address(GetType(), m_address, 2);
+    return Address(GetType(), m_address.data(), 2);
 }
 
 uint16_t
@@ -129,7 +129,7 @@
 {
     NS_LOG_FUNCTION_NOARGS();
 
-    static uint8_t type = Address::Register();
+    static uint8_t type = Address::Register("MacAddress", 2);
     return type;
 }
 
@@ -180,19 +180,16 @@
 std::ostream&
 operator<<(std::ostream& os, const Mac16Address& address)
 {
-    uint8_t ad[2];
-    address.CopyTo(ad);
-
+    std::ios_base::fmtflags ff = os.flags();
     os.setf(std::ios::hex, std::ios::basefield);
-    os.fill('0');
-    for (uint8_t i = 0; i < 1; i++)
-    {
-        os << std::setw(2) << (uint32_t)ad[i] << ":";
-    }
-    // Final byte not suffixed by ":"
-    os << std::setw(2) << (uint32_t)ad[1];
-    os.setf(std::ios::dec, std::ios::basefield);
-    os.fill(' ');
+    auto fill = os.fill('0');
+
+    os << std::setw(2) << static_cast<uint32_t>(address.m_address[0]) << ":";
+    os << std::setw(2) << static_cast<uint32_t>(address.m_address[1]);
+
+    os.flags(ff); // Restore stream flags
+    os.fill(fill);
+
     return os;
 }
 
